import unittest
class elem:
    def __init__(self,prev,item,next):
        self.prev = prev
        self.item = item
        self.next = next

class DoubleLinkedList:
    def __init__(self):
        self._end = elem((),"endmarker",())
        self._begin = self._end
    
    def append(self,item):
        prev = self._end.prev    
        theelem = elem(prev,item,self._end)
        if prev == ():
            self._begin = theelem
        else:
            prev.next = theelem
        self._end.prev = theelem

    """
    def insert(self,iter,item):
        prev = iter.pos.prev    
        theelem = elem(iter.pos.prev,item,iter.pos)
        if prev == ():
            self._begin = theelem
        else:
            iter.pos.prev.next = theelem
        iter.pos.prev = theelem
    """

    def insert(self,iter,item):
        origiter = iter
        prev = iter.pos.prev    
        theelem = elem(iter.pos.prev,item,iter.pos)
        if prev == ():
            self._begin = theelem
        else:
            iter.pos.prev.next = theelem
        iter.pos.prev = theelem
        iter.pos = theelem
    
    
    def replace(self,iter,item):
        iter.pos.item = item

    def delete(self,iter):
        iter.pos.prev.next = iter.pos.next 
        iter.pos.next.prev = iter.pos.prev

    def moveRegion(self,begin,end,it):
        lastelem = end.pos.prev
        #disconnect region
        if begin.pos.prev == ():
            self._begin = end.pos
        else:
            begin.pos.prev.next = end.pos
        end.pos.prev = begin.pos.prev

        # connect region in new place
        if it.pos.prev == ():
            self._begin = begin.pos
        else:
            it.pos.prev.next = begin.pos
        begin.pos.prev = it.pos.prev
        it.pos.prev = lastelem
        lastelem.next = it.pos



    def begin(self):
        return linkedlist_iter(self._begin)

    def end(self):
        return linkedlist_iter(self._end)

        
    def __iter__(self):
        return self.begin()

    def __repr__(self):
        val = '['
        comma = ''
        for i in self:
            val += comma + str(i)
            comma = ', '
        return val +']'

    def __eq__(self,other):
        it = self.begin()
        it2 = other.begin()
        while it != self.end():
            if it.deref() != it2.deref():
                return 0
            it.preincr()
            it2.preincr()
        return it2 == other.end()

    def __ne__(self,other):
        return not self.__eq__(other)

class linkedlist_iter:

    def __init__(self,pos):
        self.pos = pos
    
    def __iter__(self):
        return self

    def deref(self):
        return self.pos.item

    def preincr(self):
        self.pos = self.pos.next
        return self

    def clone(self):
        return linkedlist_iter(self.pos)

    def next(self):
        if self.pos.next == ():
            raise StopIteration
        item = self.pos.item
        self.pos = self.pos.next
        return item

    def predecr(self):
        self.pos = self.pos.prev
        return self

    def __eq__(self,other):
        return self.pos == other.pos

    def __ne__(self,other):
        return self.pos != other.pos
    


class region:
    def __init__(self,begin,end):
        self.begin = begin
        self.end = end

    def __eq__(self,other):
        return self.begin == other.begin and self.end == other.end

    def __ne__(self,other):
        return not self.__eq__(other)

    def __repr__(self):
        it = self.begin.clone()
        res = "["
        comma = ""
        while it != self.end:
            res += comma + str(it.deref())
            comma = ", "
            it.preincr()
        res += "]"
        return res
