class Vector(list):
    def __iter__(self):
        return linkedlist_iter(self,0)

    def begin(self):
        return linkedlist_iter(self,0)

    def end(self):
        return linkedlist_iter(self,len(self))

    def delete(self,iter):
        del self[iter]

    def replace(self,iter,elem):
        self[iter.pos] = elem

class region:
    def __init__(self,begin,end):
        self.begin = begin
        self.end = end

    def __eq__(self,other):
        return self.begin == other.begin and self.end == other.end

    def __ne__(self,other):
        return not self.__eq__(other)
        

    def __repr__(self):
        it = self.begin.clone()
        res = "["
        comma = ""
        while it != self.end:
            res += comma + str(it.deref())
            comma = ", "
            it.preincr()
        res += "]"
        return res

class linkedlist_iter:

    def __init__(self,list,pos):
        self.list = list
        self.pos = pos
    
    def __iter__(self):
        return self

    def deref(self):
        return self.list[self.pos]

    # increment position, return iterator 
    def preincr(self):
        self.pos +=1
        return self

    def next(self):
        if self == self.list.end():
            raise StopIteration
        item = self.deref()
        self.preincr()
        return item        

    def predecr(self):
        self.pos -=1
        return self

    def clone(self):
        return linkedlist_iter(self.list,self.pos)

    def __int__(self):
        return self.pos     # used for insert etc..

    def __eq__(self,other):
        return self.pos == other.pos

    def __ne__(self,other):
        return self.pos != other.pos
        
if __name__ == "__main__":
    unittest.main()
